function togg_search_fld(divid){
	var my_div = document.getElementById(divid);
	if (my_div){
		if (my_div.style.display == "none") {
			hideErrorMyFast();
			my_div.style.display = "block";
			var my_height = Math.floor(my_div.offsetHeight / 2);
			my_div.style.top = "50%";
			my_div.style.marginTop = "-"+my_height+"px";
			switchOnModal(divid);
			values_request(divid);
		} else {
			my_div.style.display = "none";
			switchOffModal(divid);
		}
	}
}

function switchOnModal(){
	modal_div = document.getElementById('modal-overlay');
	if(modal_div){
		modal_div.style.visibility = 'visible';
	}
	wrapper_div = document.getElementById('wrapper');
	if(wrapper_div){
		wrapper_div.classList.add("alerting");
	}
}

function switchOffModal(){
	modal_div = document.getElementById('modal-overlay');
	if(modal_div){
		modal_div.style.visibility = 'hidden';
	}
	wrapper_div = document.getElementById('wrapper');
	if(wrapper_div){
		wrapper_div.classList.remove("alerting");
	}
}

function values_request(whatform){
	var requestURL = '/fillform?formname=' + whatform ;
	var request = new XMLHttpRequest();
	request.open('GET', requestURL);
	request.responseType = 'json';
	request.send();
	request.onload = function() {
		var myFields = request.response;
		values_substitute(myFields);
	}
}

function values_substitute(jsonobj){
	for (key in jsonobj) {
		if (jsonobj.hasOwnProperty(key)) {
			if(key == 'error'){
				showErrorMy(jsonobj[key]);
			}
			var fieldForInput = document.getElementById(key)
			if(fieldForInput){
				if(fieldForInput.tagName == "INPUT" && fieldForInput.getAttribute('type') === 'checkbox') {
					if(fieldForInput.checked != jsonobj[key]){
						fieldForInput.click();
					}
				} else if(fieldForInput.tagName == "INPUT") {
					fieldForInput.value = jsonobj[key] ;
				} else if(fieldForInput.tagName == "SELECT") {
					fieldForInput.value = jsonobj[key] ;
				} else {
					fieldForInput.innerHTML = fieldForInput.httpContent = jsonobj[key] ;
				}
			}
			if(key == 'devicename'){
				var testString = document.title;
				if(testString != "" && !testString.includes(jsonobj[key])){
					document.title = testString + " " + jsonobj[key];
				}
			}
			if(key == 'row_no'){
				if(isNaN(jsonobj[key])){
					let el = document.getElementById("row_no");
					el.classList.remove("working");
					var elements1 = document.querySelectorAll(`tr[id^="taskrow"]`);
					elements1.forEach(element => {
						element.style.background ='white';
					});
				} else {
					let el = document.getElementById("row_no");
					el.classList.add("working");
					var row_id = document.getElementById('taskrow' + jsonobj[key]);
					if(row_id){
						row_id.style.background ='#f0b9b9';
					}
				}
			}
		}
	}
}

function showErrorMy(errMsg){
	oldMsgDiv = document.getElementById("popup_msg");
	if(oldMsgDiv) { oldMsgDiv.remove(); }
	var newDiv = document.createElement('div');
	newDiv.setAttribute("id","popup_msg");
	newDiv.setAttribute("onClick","javascript: hideErrorMy();");
	refr_div = document.getElementById('wrapper');
	document.body.insertBefore(newDiv,refr_div);
	totMsg = '<h1>' + errMsg +'</h1><p>Щелкните сообщение, чтобы убрать его.</p>';
	newDiv.innerHTML = newDiv.httpContent = totMsg ;
	var my_height = Math.floor(newDiv.offsetHeight / 2);
	newDiv.style.marginTop = "-"+my_height+"px";
	newDiv.classList.add("shownow");
}

function hideErrorMy(){
	document.getElementById('popup_msg').style.opacity = '0';
	setTimeout("document.getElementById('popup_msg').style.display = 'none'",1000);
}

function hideErrorMyFast(){
	var toHideDiv = document.getElementById('popup_msg');
	if(toHideDiv){
		toHideDiv.style.opacity = '0';
		setTimeout("document.getElementById('popup_msg').style.display = 'none'",50);
	}
}


function editrow(row_number){
	togg_search_fld("schedulebox");
	var place1 = document.getElementById('row_number');
	if(place1){
		place1.innerHTML = place1.httpContent = row_number + 1 ;
	}
	var place2 = document.getElementById('row');
	if(place2){
		place2.value = row_number;
	}
	
	var requestURL = '/schedrow?rownumber=' + row_number ;
	var request = new XMLHttpRequest();
	request.open('GET', requestURL);
	request.responseType = 'json';
	request.send();
	request.onload = function() {
		var myFields = request.response;
		values_substitute(myFields);
	}
}

window.addEventListener("load",function() {
	values_request("mainpage");
	setInterval(function(){
		values_request("mainpage");
	}, 2000);
	show_last_schedule();
});

document.addEventListener('mouseup', function (e) {
	var pressed_element_id = e.target.id;
	if (pressed_element_id == 'home'){
		document.location.reload();
	} else if (pressed_element_id == 'iot'){
		togg_search_fld('mqttbox');
	} else if (pressed_element_id == 'settings'){
		togg_search_fld('settingsbox');
	} else if (pressed_element_id == 'wifimenu'){
		togg_search_fld('wifibox');
	} else if (pressed_element_id == 'power_state_button'){
		values_request('power_state');
	} else if (pressed_element_id == 'showforce'){
		values_request('showforce');
	} else if (pressed_element_id == 'wifi_scan'){
		values_request('wifi_scan');
	} else if (pressed_element_id == 'upgrademenu'){
		window.open('/update','_blank');
	} else if (pressed_element_id == 'counterreset'){
		e.preventDefault();
		if(confirm("Вы действительно хотите сбросить счетчик общего времени наработки?")){
			alert('ОК');
			window.location.replace("/totalcounerreset");
		}
	} else {
/*		var container = document.getElementById('setzerobox');
		if (!container.contains(e.target) && container.style.display == "block") {
			togg_search_fld('setzerobox');
		}
*/
		var container = document.getElementById('settingsbox');
		if (!container.contains(e.target) && container.style.display == "block") {
			togg_search_fld('settingsbox');
		}
		var container = document.getElementById('schedulebox');
		if (!container.contains(e.target) && container.style.display == "block") {
			togg_search_fld('schedulebox');
		}
		var container = document.getElementById('mqttbox');
		if (!container.contains(e.target) && container.style.display == "block") {
			togg_search_fld('mqttbox');
		}
		var container = document.getElementById('wifibox');
		if (!container.contains(e.target) && container.style.display == "block") {
			togg_search_fld('wifibox');
		}
	}
});

function updateLog(newText){
	let elem = document.getElementById('divForGraph');
	elem.innerHTML = elem.httpContent = newText;
}

function show_last_schedule(){
	var requestURL = '/getscedule?k=' + Math.random() ;
	var request = new XMLHttpRequest();
	request.open('GET', requestURL);
	request.send();
	request.onload = function() {
		var myFields = request.response;
		updateLog(myFields);
	}
}

function showhelp(){
	window.open('/files/help.html','_blank');
}
